diff -r e16bdc0054ce src/misc_gui.cpp
--- a/src/misc_gui.cpp
+++ b/src/misc_gui.cpp
@@ -25,6 +25,7 @@
 #include "querystring_gui.h"
 #include "core/geometry_func.hpp"
 #include "newgrf_debug.h"
+#include "newgrf_cargo.h"
 #include "zoom_func.h"
 
 #include "widgets/misc_widget.h"
@@ -33,6 +34,14 @@
 
 #include "safeguards.h"
 
+#include "house.h"
+#include "town_map.h"
+#include "station_base.h"
+#include "viewport_func.h"
+#include "industry.h"
+
+void GuiShowTooltipsExtra(Window *parent, uint param, TooltipCloseCondition close_tooltip);
+
 /** Method to open the OSK. */
 enum OskActivation {
 	OSKA_DISABLED,           ///< The OSK shall not be activated at all.
@@ -43,16 +52,11 @@
 
 
 static const NWidgetPart _nested_land_info_widgets[] = {
-	NWidget(NWID_HORIZONTAL),
-		NWidget(WWT_CLOSEBOX, COLOUR_GREY),
-		NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_LAND_AREA_INFORMATION_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
-		NWidget(WWT_DEBUGBOX, COLOUR_GREY),
-	EndContainer(),
-	NWidget(WWT_PANEL, COLOUR_GREY, WID_LI_BACKGROUND), EndContainer(),
+	NWidget(WWT_PANEL, COLOUR_GREY, WID_LI_BACKGROUND), SetMinimalSize(64, 32),	EndContainer(),
 };
 
 static WindowDesc _land_info_desc(
-	WDP_AUTO, "land_info", 0, 0,
+	WDP_MANUAL, "land_info", 0, 0,
 	WC_LAND_INFO, WC_NONE,
 	0,
 	_nested_land_info_widgets, lengthof(_nested_land_info_widgets)
@@ -70,11 +74,28 @@
 public:
 	char landinfo_data[LAND_INFO_LINE_END][LAND_INFO_LINE_BUFF_SIZE];
 	TileIndex tile;
+	TileIndex end_tile;  ///< For use in ruler(dragdrop) mode
+
+	virtual Point OnInitialPosition(int16 sm_width, int16 sm_height, int window_number)
+	{
+		int scr_top = GetMainViewTop() + 2;
+		int scr_bot = GetMainViewBottom() - 2;
+		Point pt;
+		pt.y = Clamp(_cursor.pos.y + _cursor.size.y + _cursor.offs.y + 5, scr_top, scr_bot);
+		if (pt.y + sm_height > scr_bot) pt.y = min(_cursor.pos.y + _cursor.offs.y - 5, scr_bot) - sm_height;
+		pt.x = sm_width >= _screen.width ? 0 : Clamp(_cursor.pos.x - (sm_width >> 1), 0, _screen.width - sm_width);
+		return pt;
+	}
 
 	virtual void DrawWidget(const Rect &r, int widget) const
 	{
 		if (widget != WID_LI_BACKGROUND) return;
 
+		GfxDrawLine(r.left,  r.top,    r.right, r.top,    PC_BLACK);
+		GfxDrawLine(r.left,  r.bottom, r.right, r.bottom, PC_BLACK);
+		GfxDrawLine(r.left,  r.top,    r.left,  r.bottom, PC_BLACK);
+		GfxDrawLine(r.right, r.top,    r.right, r.bottom, PC_BLACK);
+
 		uint y = r.top + WD_TEXTPANEL_TOP;
 		for (uint i = 0; i < LAND_INFO_CENTERED_LINES; i++) {
 			if (StrEmpty(this->landinfo_data[i])) break;
@@ -113,9 +134,11 @@
 		}
 	}
 
-	LandInfoWindow(TileIndex tile) : Window(&_land_info_desc), tile(tile)
+	LandInfoWindow(TileIndex tile, TileIndex end_tile=INVALID_TILE) :
+		Window(&_land_info_desc), tile(tile), end_tile(end_tile)
 	{
 		this->InitNested();
+		CLRBITS(this->flags, WF_WHITE_BORDER);
 
 #if defined(_DEBUG)
 #	define LANDINFOD_LEVEL 0
@@ -164,6 +187,7 @@
 		td.airport_tile_name = STR_NULL;
 		td.rail_speed = 0;
 		td.road_speed = 0;
+		td.population = 0;
 
 		td.grf = NULL;
 
@@ -293,6 +317,13 @@
 			line_nr++;
 		}
 
+		/* House pop */
+		if (td.population != 0) {
+			SetDParam(0, td.population);
+			GetString(this->landinfo_data[line_nr], STR_LAND_AREA_INFORMATION_POP, lastof(this->landinfo_data[line_nr]));
+			line_nr++;
+		}
+
 		assert(line_nr < LAND_INFO_CENTERED_LINES);
 
 		/* Mark last line empty */
@@ -349,16 +380,34 @@
 				break;
 		}
 	}
+
+	virtual void OnMouseLoop()
+	{
+		/* Always close tooltips when the cursor is not in our window. */
+		if (!_cursor.in_window) {
+			delete this;
+			return;
+		}
+		if (!_mouse_hovering) delete this;
+
+		/* We can show tooltips while dragging tools. These are shown as long as
+		 * we are dragging the tool. Normal tooltips work with hover or rmb. */
+		// switch (this->close_cond) {
+		// 	case TCC_RIGHT_CLICK: if (!_right_button_down) delete this; break;
+		// 	case TCC_LEFT_CLICK: if (!_left_button_down) delete this; break;
+		// 	case TCC_HOVER: if (!_mouse_hovering) delete this; break;
+		// }
+	}
 };
 
 /**
  * Show land information window.
  * @param tile The tile to show information about.
  */
-void ShowLandInfo(TileIndex tile)
+void ShowLandInfo(TileIndex tile, TileIndex end_tile)
 {
 	DeleteWindowById(WC_LAND_INFO, 0);
-	new LandInfoWindow(tile);
+	new LandInfoWindow(tile, end_tile);
 }
 
 static const NWidgetPart _nested_about_widgets[] = {
@@ -1208,3 +1257,495 @@
 
 	new QueryWindow(&_query_desc, caption, message, parent, callback);
 }
+
+/** Window for displaying a tooltip. */
+void GuiPrepareTooltipsExtra(Window *parent){
+	const Point p = GetTileBelowCursor();
+	if (p.x == -1) return;
+	const TileIndex tile = TileVirtXY(p.x, p.y);
+
+	if (_cursor.sprite == SPR_CURSOR_QUERY) {
+		// Land info tool active
+		ShowLandInfo(tile);
+		return;
+	}
+
+	if (!_settings_client.gui.enable_extra_tooltips)
+		return;
+
+	if (tile >= MapSize()) return;
+	uint param = 0;
+	switch (GetTileType(tile)) {
+		/*case MP_HOUSE: {
+			const HouseID house = GetHouseType(tile);
+			param = ((house & 0xFFFF) << 16) | MP_HOUSE;
+			break;
+		}*/
+		case MP_INDUSTRY: {
+			const Industry *ind = Industry::GetByTile(tile);
+			if(ind->produced_cargo[0] == CT_INVALID && ind->produced_cargo[1] == CT_INVALID) return;
+			param = ((ind->index & 0xFFFF) << 16) | MP_INDUSTRY;
+			break;
+		}
+		case MP_STATION: {
+			if (IsRailWaypoint(tile) || HasTileWaterGround(tile)) break;
+			const Station *st = Station::GetByTile(tile);
+			param |= ((st->index & 0xFFFF) << 16) | MP_STATION;
+			break;
+		}
+		default:
+			return;
+	}
+	if(param != 0) GuiShowTooltipsExtra(parent, param, TCC_HOVER);
+}
+
+static const NWidgetPart _nested_tooltips_extra_widgets[] = {
+	NWidget(WWT_PANEL, COLOUR_GREY, WID_TT_BACKGROUND), SetMinimalSize(64, 32),	EndContainer(),
+};
+
+static WindowDesc _tool_tips_extra_desc(
+	WDP_MANUAL, NULL, 0, 0,
+	WC_TOOLTIPS_EXTRA, WC_NONE,
+	0,
+	_nested_tooltips_extra_widgets, lengthof(_nested_tooltips_extra_widgets)
+);
+
+struct TooltipsExtraWindow : public Window
+{
+	TileType tiletype;
+	uint16 objIndex;
+	TooltipCloseCondition close_cond;
+
+	TooltipsExtraWindow(Window *parent, uint param, TooltipCloseCondition close_tooltip) : Window(&_tool_tips_extra_desc)
+	{
+		this->parent = parent;
+		this->tiletype = (TileType)(param & 0xFFFF);
+		this->objIndex = (uint16)((param >> 16) & 0xFFFF);
+		this->close_cond = close_tooltip;
+		this->InitNested();
+		CLRBITS(this->flags, WF_WHITE_BORDER);
+	}
+
+	virtual Point OnInitialPosition(int16 sm_width, int16 sm_height, int window_number)
+	{
+		int scr_top = GetMainViewTop() + 2;
+		int scr_bot = GetMainViewBottom() - 2;
+		Point pt;
+		pt.y = Clamp(_cursor.pos.y + _cursor.size.y + _cursor.offs.y + 5, scr_top, scr_bot);
+		if (pt.y + sm_height > scr_bot) pt.y = min(_cursor.pos.y + _cursor.offs.y - 5, scr_bot) - sm_height;
+		pt.x = sm_width >= _screen.width ? 0 : Clamp(_cursor.pos.x - (sm_width >> 1), 0, _screen.width - sm_width);
+		return pt;
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		uint icon_size = ScaleGUITrad(10);
+		uint line_height = max((uint)FONT_HEIGHT_NORMAL, icon_size) + 2;
+		uint icons_width = icon_size * 3 + 20;
+		size->width = 200;
+		size->height = FONT_HEIGHT_NORMAL + 6;
+		switch(this->tiletype) {
+			/*case MP_HOUSE: {
+				size->height += LINE_HEIGHT;
+				SetDParam(0, 1000);
+				size->width = GetStringBoundingBox(STR_TTE_HOUSE).width;
+				break;
+			}*/
+			case MP_INDUSTRY: {
+				const Industry *ind = Industry::GetIfValid((IndustryID)this->objIndex);
+				if(ind == NULL) break;
+
+				for (CargoID i = 0; i < lengthof(ind->produced_cargo); i++) {
+					if (ind->produced_cargo[i] == CT_INVALID) continue;
+					const CargoSpec *cs = CargoSpec::Get(ind->produced_cargo[i]);
+					if(cs == NULL) continue;
+					size->height += line_height;
+					SetDParam(0, cs->name);
+					SetDParam(1, cs->Index());
+					SetDParam(2, ind->last_month_production[i]);
+					SetDParam(3, ToPercent8(ind->last_month_pct_transported[i]));
+					size->width = max(GetStringBoundingBox(STR_TTE_INDUSTRY).width + icons_width, size->width);
+				}
+				break;
+			}
+			case MP_STATION: {
+				const Station *st = Station::GetIfValid((StationID)this->objIndex);
+				if(st == NULL) break;
+
+				for (int i = 0; i < _sorted_standard_cargo_specs_size; i++) {
+					const CargoSpec *cs = _sorted_cargo_specs[i];
+					if(cs == NULL) continue;
+					int cargoid = cs->Index();
+					if (HasBit(st->goods[cargoid].status, GoodsEntry::GES_RATING)) {
+						size->height += line_height;
+						SetDParam(0, cs->name);
+						SetDParam(1, cargoid);
+						SetDParam(2, st->goods[cargoid].cargo.TotalCount());
+						SetDParam(3, ToPercent8(st->goods[cargoid].rating));
+						size->width = max(GetStringBoundingBox(STR_TTE_STATION).width + icons_width, size->width);
+					}
+				}
+				break;
+			}
+			default:
+				break;
+		}
+		size->width  += 2 + WD_FRAMERECT_LEFT + WD_FRAMERECT_RIGHT;
+		size->height += 2 + WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM;
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		uint icon_size = ScaleGUITrad(10);
+		uint line_height = max((uint)FONT_HEIGHT_NORMAL, icon_size) + 2;
+		uint icons_width = icon_size * 3 + 10;
+		uint text_ofs = (line_height - FONT_HEIGHT_NORMAL) >> 1;
+		uint icon_ofs = (line_height - icon_size) >> 1;
+
+		GfxDrawLine(r.left,  r.top,    r.right, r.top,    PC_BLACK);
+		GfxDrawLine(r.left,  r.bottom, r.right, r.bottom, PC_BLACK);
+		GfxDrawLine(r.left,  r.top,    r.left,  r.bottom, PC_BLACK);
+		GfxDrawLine(r.right, r.top,    r.right, r.bottom, PC_BLACK);
+
+		int y = r.top + WD_FRAMERECT_TOP + 4;
+		int left = r.left + WD_FRAMERECT_LEFT + 4;
+
+		switch(this->tiletype) {
+			/*case MP_HOUSE: {
+				const HouseID house = (HouseID)this->objIndex;
+				const HouseSpec *hs = HouseSpec::Get(house);
+				if(hs == NULL) break;
+
+				SetDParam(0, hs->building_name);
+				DrawString(left, r.right - WD_FRAMERECT_RIGHT, y, STR_TTE_HOUSE_NAME, TC_BLACK, SA_CENTER);
+				y += LINE_HEIGHT;
+				SetDParam(0, hs->population);
+				DrawString(left, r.right - WD_FRAMERECT_RIGHT, y, STR_TTE_HOUSE);
+				break;
+			}*/
+			case MP_INDUSTRY: {
+				const Industry *ind = Industry::GetIfValid((IndustryID)this->objIndex);
+				if(ind == NULL) break;
+
+				SetDParam(0, ind->index);
+				DrawString(left, r.right - WD_FRAMERECT_RIGHT, y, STR_TTE_INDUSTRY_NAME, TC_BLACK, SA_CENTER);
+				y += FONT_HEIGHT_NORMAL + 2;
+
+				for (CargoID i = 0; i < lengthof(ind->produced_cargo); i++) {
+					if (ind->produced_cargo[i] == CT_INVALID) continue;
+					const CargoSpec *cs = CargoSpec::Get(ind->produced_cargo[i]);
+					if(cs == NULL) continue;
+					SetDParam(0, cs->name);
+					SetDParam(1, cs->Index());
+					SetDParam(2, ind->last_month_production[i]);
+					SetDParam(3, ToPercent8(ind->last_month_pct_transported[i]));
+
+					this->DrawSpriteIcons(cs->GetCargoIcon(), left, y + icon_ofs);
+					DrawString(left + icons_width, r.right - WD_FRAMERECT_RIGHT, y + text_ofs, STR_TTE_INDUSTRY);
+					y += line_height;
+				}
+				break;
+			}
+			case MP_STATION: {
+				const Station *st = Station::GetIfValid((StationID)this->objIndex);
+				if(st == NULL) break;
+
+				SetDParam(0, st->index);
+				DrawString(left, r.right - WD_FRAMERECT_RIGHT, y, STR_TTE_STATION_NAME, TC_BLACK, SA_CENTER);
+				y += FONT_HEIGHT_NORMAL + 2;
+
+				for (int i = 0; i < _sorted_standard_cargo_specs_size; i++) {
+					const CargoSpec *cs = _sorted_cargo_specs[i];
+					if(cs == NULL) continue;
+					int cargoid = cs->Index();
+					if (HasBit(st->goods[cargoid].status, GoodsEntry::GES_RATING)) {
+						SetDParam(0, cs->name);
+						SetDParam(1, cargoid);
+						SetDParam(2, st->goods[cargoid].cargo.TotalCount());
+						SetDParam(3, ToPercent8(st->goods[cargoid].rating));
+
+						this->DrawSpriteIcons(cs->GetCargoIcon(), left, y + icon_ofs);
+						DrawString(left + icons_width, r.right - WD_FRAMERECT_RIGHT, y + text_ofs, STR_TTE_STATION);
+						y += line_height;
+					}
+				}
+				break;
+			}
+			default:
+				break;
+		}
+	}
+
+	virtual void OnMouseLoop()
+	{
+		if (!_cursor.in_window) {
+			delete this;
+			return;
+		}
+
+		switch (this->close_cond) {
+			case TCC_RIGHT_CLICK: if (!_right_button_down) delete this; break;
+			case TCC_LEFT_CLICK: if (!_left_button_down) delete this; break;
+			case TCC_HOVER: if (!_mouse_hovering) delete this; break;
+		}
+	}
+
+	void DrawSpriteIcons(SpriteID sprite, int left, int top) const
+	{
+		uint step = ScaleGUITrad(10);
+		for(int i = 0; i < 3; i++) {
+			DrawSprite(sprite, PAL_NONE, left + i * step, top);
+		}
+	}
+};
+
+static const NWidgetPart _nested_station_rating_tooltip_widgets[] = {
+	NWidget(WWT_PANEL, COLOUR_GREY, WID_TT_BACKGROUND), SetMinimalSize(64, 32),	EndContainer(),
+};
+
+static WindowDesc _station_rating_tooltip_desc(
+	WDP_MANUAL, NULL, 0, 0,
+	WC_STATION_RATING_TOOLTIP, WC_NONE,
+	0,
+	_nested_tooltips_extra_widgets, lengthof(_nested_station_rating_tooltip_widgets)
+);
+
+static const int STATION_RATING_AGE[] = {0, 10, 20, 33};
+static const int STATION_RATING_WAITTIME[] = {0, 25, 50, 95, 130};
+static const int STATION_RATING_WAITUNITS[] = {-90, -35, 0, 10, 30, 40};
+
+
+struct StationRatingTooltipWindow : public Window
+{
+	TileType tiletype;
+	uint16 objIndex;
+	TooltipCloseCondition close_cond;
+	const Station *st;
+	const CargoSpec *cs;
+	bool newgrf_rating_used;
+
+	static const uint RATING_TOOLTIP_LINE_BUFF_SIZE = 512;
+	static const uint RATING_TOOLTIP_MAX_LINES = 8;
+	static const uint RATING_TOOLTIP_NEWGRF_INDENT = 20;
+
+public:
+	char data[RATING_TOOLTIP_MAX_LINES + 1][RATING_TOOLTIP_LINE_BUFF_SIZE];
+
+	StationRatingTooltipWindow(Window *parent, const Station *st, const CargoSpec *cs) : Window(&_station_rating_tooltip_desc)
+	{
+		this->parent = parent;
+		this->st = st;
+		this->cs = cs;
+		this->InitNested();
+		CLRBITS(this->flags, WF_WHITE_BORDER);
+	}
+
+	virtual Point OnInitialPosition(int16 sm_width, int16 sm_height, int window_number)
+	{
+		int scr_top = GetMainViewTop() + 2;
+		int scr_bot = GetMainViewBottom() - 2;
+		Point pt;
+		pt.y = Clamp(_cursor.pos.y + _cursor.size.y + _cursor.offs.y + 5, scr_top, scr_bot);
+		if (pt.y + sm_height > scr_bot) pt.y = min(_cursor.pos.y + _cursor.offs.y - 5, scr_bot) - sm_height;
+		pt.x = sm_width >= _screen.width ? 0 : Clamp(_cursor.pos.x - (sm_width >> 1), 0, _screen.width - sm_width);
+		return pt;
+	}
+
+	int RoundRating(int rating) {
+		// if (rating >= 0) {
+		// 	return rating * 101 +
+		// }
+		return RoundDivSU(rating * 101, 256);
+	}
+
+	virtual void OnInit() {
+		const GoodsEntry *ge = &this->st->goods[this->cs->Index()];
+
+		SetDParam(0, this->cs->name);
+		GetString(this->data[0], STR_STATION_RATING_TOOLTIP_RATING_DETAILS, lastof(this->data[0]));
+		if (!ge->HasRating()) {
+			this->data[1][0] = '\0';
+			return;
+		}
+
+		uint line_nr = 1;
+		int total_rating = 0;
+
+		if (HasBit(cs->callback_mask, CBM_CARGO_STATION_RATING_CALC)) {
+			uint last_speed = ge->HasVehicleEverTriedLoading() ? ge->last_speed : 0xFF;
+
+			uint32 var18 = min(ge->time_since_pickup, 0xFF) | (min(ge->max_waiting_cargo, 0xFFFF) << 8) | (min(last_speed, 0xFF) << 24);
+			uint32 var10 = (this->st->last_vehicle_type == VEH_INVALID) ? 0x0 : (this->st->last_vehicle_type + 0x10);
+			uint16 callback = GetCargoCallback(CBID_CARGO_STATION_RATING_CALC, var10, var18, this->cs);
+			int newgrf_rating = 0;
+			if (callback != CALLBACK_FAILED) {
+				newgrf_rating = GB(callback, 0, 14);
+				if (HasBit(callback, 14)) newgrf_rating -= 0x4000;
+
+				this->newgrf_rating_used = true;
+
+				total_rating += newgrf_rating;
+				newgrf_rating = this->RoundRating(newgrf_rating);
+
+				SetDParam(0, STR_STATION_RATING_TOOLTIP_NEWGRF_RATING_0 + (newgrf_rating <= 0 ? 0 : 1));
+				SetDParam(1, newgrf_rating);
+				GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_NEWGRF_RATING, lastof(this->data[line_nr]));
+				line_nr++;
+
+				SetDParam(0, min(last_speed, 0xFF));
+				GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_NEWGRF_SPEED, lastof(this->data[line_nr]));
+				line_nr++;
+
+				SetDParam(0, min(ge->max_waiting_cargo, 0xFFFF));
+				GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_NEWGRF_WAITUNITS, lastof(this->data[line_nr]));
+				line_nr++;
+
+				SetDParam(0, (min(ge->time_since_pickup, 0xFF) * 5 + 1) / 2);
+				GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_NEWGRF_WAITTIME, lastof(this->data[line_nr]));
+				line_nr++;
+			}
+		}
+
+		if (!this->newgrf_rating_used) {
+
+			byte waittime = ge->time_since_pickup;
+			if (this->st->last_vehicle_type == VEH_SHIP) waittime >>= 2;
+			int waittime_stage = 0;
+			(waittime > 21) ||
+			(waittime_stage = 1, waittime > 12) ||
+			(waittime_stage = 2, waittime > 6) ||
+			(waittime_stage = 3, waittime > 3) ||
+			(waittime_stage = 4, true);
+			total_rating += STATION_RATING_WAITTIME[waittime_stage];
+
+			SetDParam(0, STR_STATION_RATING_TOOLTIP_WAITTIME_0 + waittime_stage);
+			SetDParam(1, (ge->time_since_pickup * 5 + 1) / 2);
+			SetDParam(2, this->RoundRating(STATION_RATING_WAITTIME[waittime_stage]));
+			GetString(this->data[line_nr], this->st->last_vehicle_type == VEH_SHIP ? STR_STATION_RATING_TOOLTIP_WAITTIME_SHIP : STR_STATION_RATING_TOOLTIP_WAITTIME, lastof(this->data[line_nr]));
+			line_nr++;
+
+			uint waitunits = ge->max_waiting_cargo;
+			int waitunits_stage = 0;
+			(ge->max_waiting_cargo > 1500) ||
+			(waitunits_stage = 1, ge->max_waiting_cargo > 1000) ||
+			(waitunits_stage = 2, ge->max_waiting_cargo > 600) ||
+			(waitunits_stage = 3, ge->max_waiting_cargo > 300) ||
+			(waitunits_stage = 4, ge->max_waiting_cargo > 100) ||
+			(waitunits_stage = 5, true);
+			total_rating += STATION_RATING_WAITUNITS[waitunits_stage];
+
+			SetDParam(0, STR_STATION_RATING_TOOLTIP_WAITUNITS_0 + waitunits_stage);
+			SetDParam(1, ge->max_waiting_cargo);
+			SetDParam(2, this->RoundRating(STATION_RATING_WAITUNITS[waitunits_stage]));
+			GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_WAITUNITS, lastof(this->data[line_nr]));
+			line_nr++;
+
+			int b = ge->last_speed - 85;
+			int r_speed = b >= 0 ? b >> 2 : 0;
+			int r_speed_round = this->RoundRating(r_speed);
+			total_rating += r_speed;
+			if (ge->last_speed == 255) {
+				SetDParam(0, STR_STATION_RATING_TOOLTIP_SPEED_MAX);
+			} else if (r_speed_round == 0) {
+				SetDParam(0, STR_STATION_RATING_TOOLTIP_SPEED_ZERO);
+			} else {
+				SetDParam(0, STR_STATION_RATING_TOOLTIP_SPEED_0 + r_speed / 11);
+			}
+			SetDParam(0, ge->last_speed == 255 ? STR_STATION_RATING_TOOLTIP_SPEED_MAX : STR_STATION_RATING_TOOLTIP_SPEED_0 + r_speed / 11);
+			SetDParam(1, ge->last_speed);
+			SetDParam(2, r_speed_round);
+			GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_SPEED, lastof(this->data[line_nr]));
+			line_nr++;
+		}
+
+		int age_stage = (ge->last_age >= 3 ? 0 : 3 - ge->last_age);
+		total_rating += STATION_RATING_AGE[age_stage];
+		SetDParam(0, STR_STATION_RATING_TOOLTIP_AGE_0 + age_stage);
+		SetDParam(1, ge->last_age);
+		SetDParam(2, this->RoundRating(STATION_RATING_AGE[age_stage]));
+		GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_AGE, lastof(this->data[line_nr]));
+		line_nr++;
+
+		if (Company::IsValidID(st->owner) && HasBit(st->town->statues, st->owner)) {
+			SetDParam(0, STR_STATION_RATING_TOOLTIP_STATUE_YES);
+			total_rating += 26;
+		} else {
+			SetDParam(0, STR_STATION_RATING_TOOLTIP_STATUE_NO);
+		}
+		GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_STATUE, lastof(this->data[line_nr]));
+		line_nr++;
+
+		SetDParam(0, ToPercent8(Clamp(total_rating, 0, 255)));
+		GetString(this->data[line_nr], STR_STATION_RATING_TOOLTIP_TOTAL_RATING, lastof(this->data[line_nr]));
+		line_nr++;
+
+		this->data[line_nr][0] = '\0';
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		if (widget != WID_LI_BACKGROUND) return;
+
+		size->height = WD_FRAMETEXT_TOP + WD_FRAMETEXT_BOTTOM + 2;
+		for (uint i = 0; i <= RATING_TOOLTIP_MAX_LINES; i++) {
+			if (StrEmpty(this->data[i])) break;
+
+			uint width = GetStringBoundingBox(this->data[i]).width + WD_FRAMETEXT_LEFT + WD_FRAMETEXT_RIGHT + 2;
+			if (this->newgrf_rating_used && i >= 2 && i <= 4)
+				width += RATING_TOOLTIP_NEWGRF_INDENT;
+			size->width = max(size->width, width);
+			size->height += FONT_HEIGHT_NORMAL + WD_PAR_VSEP_NORMAL;
+		}
+		size->height -= WD_PAR_VSEP_NORMAL;
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		uint icon_size = ScaleGUITrad(10);
+		uint line_height = max((uint)FONT_HEIGHT_NORMAL, icon_size) + 2;
+		uint text_ofs = (line_height - FONT_HEIGHT_NORMAL) >> 1;
+		uint icon_ofs = (line_height - icon_size) >> 1;
+
+		GfxDrawLine(r.left,  r.top,    r.right, r.top,    PC_BLACK);
+		GfxDrawLine(r.left,  r.bottom, r.right, r.bottom, PC_BLACK);
+		GfxDrawLine(r.left,  r.top,    r.left,  r.bottom, PC_BLACK);
+		GfxDrawLine(r.right, r.top,    r.right, r.bottom, PC_BLACK);
+
+		int y = r.top + WD_FRAMETEXT_TOP + 1;
+		int left0 = r.left + WD_FRAMETEXT_LEFT + 1;
+		int right0 = r.right - WD_FRAMETEXT_RIGHT - 1;
+		DrawString(left0, right0, y, this->data[0], TC_LIGHT_BLUE, SA_CENTER);
+		y += FONT_HEIGHT_NORMAL + WD_PAR_VSEP_NORMAL;
+		for (uint i = 1; i <= RATING_TOOLTIP_MAX_LINES; i++) {
+			if (StrEmpty(this->data[i])) break;
+			int left = left0, right = right0;
+			if (this->newgrf_rating_used && i >= 2 && i <= 4) {
+				if (_current_text_dir == TD_RTL) {
+					right -= RATING_TOOLTIP_NEWGRF_INDENT;
+				} else {
+					left += RATING_TOOLTIP_NEWGRF_INDENT;
+				}
+			}
+			DrawString(left, right, y, this->data[i], TC_BLACK);
+			y += FONT_HEIGHT_NORMAL + WD_PAR_VSEP_NORMAL;
+		}
+	}
+
+	virtual void OnMouseLoop()
+	{
+		if (!_cursor.in_window || !_mouse_hovering) {
+			delete this;
+		}
+	}
+};
+
+void GuiShowTooltipsExtra(Window *parent, uint param, TooltipCloseCondition close_tooltip)
+{
+	DeleteWindowById(WC_TOOLTIPS_EXTRA, 0);
+	new TooltipsExtraWindow(parent, param, close_tooltip);
+}
+
+void GuiShowStationRatingTooltip(Window *parent, const Station *st, const CargoSpec *cs) {
+	DeleteWindowById(WC_STATION_RATING_TOOLTIP, 0);
+	new StationRatingTooltipWindow(parent, st, cs);
+}
diff -r e16bdc0054ce src/network/network.cpp
--- a/src/network/network.cpp
+++ b/src/network/network.cpp
@@ -82,7 +82,7 @@
 uint16 _network_udp_broadcast;        ///< Timeout for the UDP broadcasts.
 uint8 _network_advertise_retries;     ///< The number of advertisement retries we did.
 CompanyMask _network_company_passworded; ///< Bitmask of the password status of all companies.
-
+bool _novarole = false;
 /* Check whether NETWORK_NUM_LANDSCAPES is still in sync with NUM_LANDSCAPE */
 assert_compile((int)NETWORK_NUM_LANDSCAPES == (int)NUM_LANDSCAPE);
 assert_compile((int)NETWORK_COMPANY_NAME_LENGTH == MAX_LENGTH_COMPANY_NAME_CHARS * MAX_CHAR_LENGTH);
@@ -116,6 +116,7 @@
 {
 	/* Delete the chat window, if you were chatting with this client. */
 	InvalidateWindowData(WC_SEND_NETWORK_MSG, DESTTYPE_CLIENT, this->client_id);
+	InvalidateWindowData(WC_WATCH_COMPANYA, this->client_id, 2);
 }
 
 /**
diff -r e16bdc0054ce src/network/network_client.cpp
--- a/src/network/network_client.cpp
+++ b/src/network/network_client.cpp
@@ -34,10 +34,14 @@
 
 #include "table/strings.h"
 
+#include "../town.h"
+#include "network_func.h"
+
 #include "../safeguards.h"
 
 /* This file handles all the client-commands */
 
+void SyncCMUser(const char *msg);
 
 /** Read some packets, and when do use that data as initial load filter. */
 struct PacketReader : LoadFilter {
@@ -265,6 +269,10 @@
 			if (_network_first_time) {
 				_network_first_time = false;
 				SendAck();
+				extern bool novahost();
+				if(novahost()) {
+					NetworkClientSendChatToServer("!check 1512"); //check version
+				}
 			}
 
 			_sync_frame = 0;
@@ -614,6 +622,10 @@
 		strecpy(ci->client_name, name, lastof(ci->client_name));
 
 		SetWindowDirty(WC_CLIENT_LIST, 0);
+		InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+		SetWindowClassesDirty(WC_WATCH_COMPANY);
+		InvalidateWindowData(WC_WATCH_COMPANYA, ci->client_id, 1);
+		SetWindowClassesDirty(WC_WATCH_COMPANYA);
 
 		return NETWORK_RECV_STATUS_OKAY;
 	}
@@ -633,6 +645,10 @@
 	strecpy(ci->client_name, name, lastof(ci->client_name));
 
 	SetWindowDirty(WC_CLIENT_LIST, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	SetWindowClassesDirty(WC_WATCH_COMPANY);
+	InvalidateWindowData(WC_WATCH_COMPANYA, ci->client_id, 1);
+	SetWindowClassesDirty(WC_WATCH_COMPANYA);
 
 	return NETWORK_RECV_STATUS_OKAY;
 }
@@ -984,7 +1000,8 @@
 	}
 
 	if (ci != NULL) {
-		NetworkTextMessage(action, GetDrawStringCompanyColour(ci->client_playas), self_send, name, msg, data);
+		if (strncmp(msg, "synccmuser", 10) == 0) SyncCMUser(msg);
+		else NetworkTextMessage(action, GetDrawStringCompanyColour(ci->client_playas), self_send, name, msg, data);
 	}
 	return NETWORK_RECV_STATUS_OKAY;
 }
@@ -1021,6 +1038,8 @@
 	}
 
 	SetWindowDirty(WC_CLIENT_LIST, 0);
+	InvalidateWindowClassesData( WC_WATCH_COMPANYA, 0 );
+	SetWindowClassesDirty( WC_WATCH_COMPANYA );
 
 	/* If we come here it means we could not locate the client.. strange :s */
 	return NETWORK_RECV_STATUS_OKAY;
@@ -1107,6 +1126,8 @@
 	if (client_id == _network_own_client_id) {
 		SetLocalCompany(company_id);
 	}
+	InvalidateWindowClassesData( WC_WATCH_COMPANYA, 0 );
+	SetWindowClassesDirty( WC_WATCH_COMPANYA );
 
 	return NETWORK_RECV_STATUS_OKAY;
 }
@@ -1253,6 +1274,10 @@
 	MyClient::SendChat(action, type, dest, msg, data);
 }
 
+void NetworkClientSendChatToServer(const char * msg)
+{
+	NetworkClientSendChat(NETWORK_ACTION_CHAT_CLIENT, DESTTYPE_CLIENT, CLIENT_ID_SERVER, msg);
+}
 /**
  * Set/Reset company password on the client side.
  * @param password Password to be set.
@@ -1298,4 +1323,10 @@
 	return NetworkSpectatorCount() >= (_network_server ? _settings_client.network.max_spectators : _network_server_max_spectators);
 }
 
+void SyncCMUser(const char *msg) {
+	uint user_id, role;
+	sscanf(msg + 10, "%u %u", &user_id, &role);
+	_novarole = (role >= 50);
+	DEBUG(net, 1, "CityMania user synchronized: %u %u", user_id, role);
+}
 #endif /* ENABLE_NETWORK */
diff -r e16bdc0054ce src/network/network_func.h
--- a/src/network/network_func.h
+++ b/src/network/network_func.h
@@ -38,7 +38,7 @@
 extern StringList _network_bind_list;
 extern StringList _network_host_list;
 extern StringList _network_ban_list;
-
+extern bool _novarole;
 byte NetworkSpectatorCount();
 void NetworkUpdateClientName();
 bool NetworkCompanyHasClients(CompanyID company);
@@ -57,6 +57,7 @@
 void NetworkClientRequestMove(CompanyID company, const char *pass = "");
 void NetworkClientSendRcon(const char *password, const char *command);
 void NetworkClientSendChat(NetworkAction action, DestType type, int dest, const char *msg, int64 data = 0);
+void NetworkClientSendChatToServer(const char * msg);
 bool NetworkClientPreferTeamChat(const NetworkClientInfo *cio);
 bool NetworkCompanyIsPassworded(CompanyID company_id);
 bool NetworkMaxCompaniesReached();
